Index: palm/trunk/SOURCE/land_surface_model.f90
===================================================================
--- palm/trunk/SOURCE/land_surface_model.f90	(revision 1539)
+++ palm/trunk/SOURCE/land_surface_model.f90	(revision 1551)
@@ -20,5 +20,11 @@
 ! Current revisions:
 ! -----------------
-! 
+! Flux calculation is now done in prandtl_fluxes. Added support for data output.
+! Vertical indices have been replaced. Restart runs are now possible. Some
+! variables have beem renamed. Bugfix in the prognostic equation for the surface
+! temperature. Introduced z0_eb and z0h_eb, which overwrite the setting of
+! roughness_length and z0_factor. Added Clapp & Hornberger parametrization for
+! the hydraulic conductivity. Bugfix for root fraction and extraction
+! calculation
 ! 
 ! Former revisions:
@@ -43,16 +49,18 @@
 ! scheme implemented in the ECMWF IFS model, with modifications according to
 ! H-TESSEL. The implementation is based on the formulation implemented in the 
-! DALES model.
+! DALES and UCLA-LES models.
 !
 ! To do list:
 ! -----------
-! - Add support for binary I/O support
-! - Add support for lsm data output
-! - Check for time step criterion
-! - Check use with RK-2 and Euler time-stepping
-! - Adaption for use with cloud physics (liquid water potential temperature)
-! - Check reaction of plants at wilting point and at atmospheric saturation
-! - Consider partial absorption of the net shortwave radiation by the skin layer
+! - Check dewfall parametrization for fog simulations
+! - Consider partial absorption of the net shortwave radiation by the surface layer
 ! - Allow for water surfaces, check performance for bare soils 
+! - Invert indices (running from -3 to 0. Currently: nzb_soil=0, nzt_soil=3))
+! - Implement surface runoff model (required when performing long-term LES with
+!   considerable precipitation
+! Notes:
+! ------
+! - No time step criterion is required as long as the soil layers do not become
+!   too thin
 !------------------------------------------------------------------------------!
      USE arrays_3d,                                                            &
@@ -60,19 +68,26 @@
 
      USE cloud_parameters,                                                     &
-         ONLY: cp, l_d_r, l_v, precipitation_rate, rho_l, r_d, r_v
+         ONLY:  cp, l_d_r, l_v, precipitation_rate, rho_l, r_d, r_v
 
      USE control_parameters,                                                   &
-         ONLY: dt_3d, humidity, intermediate_timestep_count,                   &
-               intermediate_timestep_count_max, precipitation, pt_surface,     &
-               rho_surface, surface_pressure, timestep_scheme, tsc
+         ONLY:  cloud_physics, dt_3d, humidity, intermediate_timestep_count,   &
+                initializing_actions, intermediate_timestep_count_max,         &
+                max_masks, precipitation, pt_surface, rho_surface,             &
+                roughness_length, surface_pressure, timestep_scheme, tsc,      &
+                z0h_factor
 
      USE indices,                                                              &
-         ONLY: nxlg, nxrg, nyng, nysg, nzb_s_inner 
+         ONLY:  nxlg, nxrg, nyng, nysg, nzb_s_inner 
 
      USE kinds
 
+    USE netcdf_control,                                                        &
+        ONLY:  dots_label, dots_num, dots_unit
+
      USE radiation_model_mod,                                                  &
-         ONLY: Rn, SW_in, sigma_SB
-
+         ONLY:  irad_scheme, rad_net, rad_sw_in, sigma_SB
+
+     USE statistics,                                                           &
+         ONLY:  hom, statistic_regions
 
     IMPLICIT NONE
@@ -80,14 +95,24 @@
 !
 !-- LSM model constants
-    INTEGER(iwp), PARAMETER :: soil_layers = 4 !: number of soil layers (fixed for now)
+    INTEGER(iwp), PARAMETER :: nzb_soil = 0, & !: bottom of the soil model (to be switched)
+                               nzt_soil = 3, & !: top of the soil model (to be switched)
+                               nzs = 4         !: number of soil layers (fixed for now)
+
+    INTEGER(iwp) :: dots_soil = 0  !: starting index for timeseries output 
+
+    INTEGER(iwp), DIMENSION(0:1) :: id_dim_zs_xy, id_dim_zs_xz, id_dim_zs_yz,  &
+                                    id_dim_zs_3d, id_var_zs_xy,                & 
+                                    id_var_zs_xz, id_var_zs_yz, id_var_zs_3d
+                                    
+    INTEGER(iwp), DIMENSION(1:max_masks,0:1) :: id_dim_zs_mask, id_var_zs_mask
 
     REAL(wp), PARAMETER ::                     &
-              b_CH               = 6.04_wp,    & ! Clapp & Hornberger exponent
-              lambda_h_dry       = 0.19_wp,    & ! heat conductivity for dry soil
+              b_ch               = 6.04_wp,    & ! Clapp & Hornberger exponent
+              lambda_h_dry       = 0.19_wp,    & ! heat conductivity for dry soil   
               lambda_h_sm        = 3.44_wp,    & ! heat conductivity of the soil matrix
               lambda_h_water     = 0.57_wp,    & ! heat conductivity of water
               psi_sat            = -0.388_wp,  & ! soil matrix potential at saturation
-              rhoC_soil          = 2.19E6_wp,  & ! volumetric heat capacity of soil
-              rhoC_water         = 4.20E6_wp,  & ! volumetric heat capacity of water
+              rho_c_soil         = 2.19E6_wp,  & ! volumetric heat capacity of soil
+              rho_c_water        = 4.20E6_wp,  & ! volumetric heat capacity of water
               m_max_depth        = 0.0002_wp     ! Maximum capacity of the water reservoir (m)
 
@@ -99,35 +124,39 @@
 
     LOGICAL :: conserve_water_content = .TRUE., & !: open or closed bottom surface for the soil model
+               dewfall = .TRUE.,                & !: allow/inhibit dewfall
                land_surface = .FALSE.             !: flag parameter indicating wheather the lsm is used
 
 !   value 9999999.9_wp -> generic available or user-defined value must be set
 !   otherwise -> no generic variable and user setting is optional
-    REAL(wp) :: alpha_VanGenuchten = 0.0_wp,            & !: NAMELIST alpha_VG
-                canopy_resistance_coefficient = 0.0_wp, & !: NAMELIST gD
-                C_skin   = 20000.0_wp,                  & !: Skin heat capacity
+    REAL(wp) :: alpha_vangenuchten = 9999999.9_wp,      & !: NAMELIST alpha_vg
+                canopy_resistance_coefficient = 9999999.9_wp, & !: NAMELIST g_d
+                c_surface   = 20000.0_wp,               & !: Surface (skin) heat capacity
                 drho_l_lv,                              & !: (rho_l * l_v)**-1
                 exn,                                    & !: value of the Exner function
                 e_s = 0.0_wp,                           & !: saturation water vapour pressure
-                field_capacity = 0.0_wp,                & !: NAMELIST m_fc
-                f_shortwave_incoming = 9999999.9_wp,    & !: NAMELIST f_SW_in
-                hydraulic_conductivity = 0.0_wp,        & !: NAMELIST gamma_w_sat
-                Ke = 0.0_wp,                            & !: Kersten number
-                lambda_skin_stable = 9999999.9_wp,      & !: NAMELIST lambda_skin_s
-                lambda_skin_unstable = 9999999.9_wp,    & !: NAMELIST lambda_skin_u
-                leaf_area_index = 9999999.9_wp,         & !: NAMELIST LAI
-                l_VanGenuchten = 0.0_WP,                & !: NAMELIST l_VG
-                min_canopy_resistance = 110.0_wp,       & !: NAMELIST r_s_min
-                m_total = 0.0_wp,                       & !: weighed total water content of the soil (m3/m3)
-                n_VanGenuchten = 0.0_WP,                & !: NAMELIST n_VG
+                field_capacity = 9999999.9_wp,          & !: NAMELIST m_fc
+                f_shortwave_incoming = 9999999.9_wp,    & !: NAMELIST f_sw_in
+                hydraulic_conductivity = 9999999.9_wp,  & !: NAMELIST gamma_w_sat
+                ke = 0.0_wp,                            & !: Kersten number
+                lambda_surface_stable = 9999999.9_wp,   & !: NAMELIST lambda_surface_s
+                lambda_surface_unstable = 9999999.9_wp, & !: NAMELIST lambda_surface_u
+                leaf_area_index = 9999999.9_wp,         & !: NAMELIST lai
+                l_vangenuchten = 9999999.9_wp,          & !: NAMELIST l_vg
+                min_canopy_resistance = 9999999.9_wp,   & !: NAMELIST r_canopy_min
+                min_soil_resistance = 50.0_wp,          & !: NAMELIST r_soil_min
+                m_total = 0.0_wp,                       & !: weighted total water content of the soil (m3/m3)
+                n_vangenuchten = 9999999.9_wp,          & !: NAMELIST n_vg
                 q_s = 0.0_wp,                           & !: saturation specific humidity
-                residual_moisture = 0.0_wp,             & !: NAMELIST m_res
+                residual_moisture = 9999999.9_wp,       & !: NAMELIST m_res
                 rho_cp,                                 & !: rho_surface * cp
                 rho_lv,                                 & !: rho * l_v
                 rd_d_rv,                                & !: r_d / r_v
-                saturation_moisture = 0.0_wp,           & !: NAMELIST m_sat
+                saturation_moisture = 9999999.9_wp,     & !: NAMELIST m_sat
                 vegetation_coverage = 9999999.9_wp,     & !: NAMELIST c_veg
-                wilting_point = 0.0_wp                    !: NAMELIST m_wilt
-
-    REAL(wp), DIMENSION(0:soil_layers-1) :: &
+                wilting_point = 9999999.9_wp,           & !: NAMELIST m_wilt
+                z0_eb  = 9999999.9_wp,                  & !: NAMELIST z0 (lsm_par)
+                z0h_eb = 9999999.9_wp                    !: NAMELIST z0h (lsm_par)
+
+    REAL(wp), DIMENSION(nzb_soil:nzt_soil) :: &
               ddz_soil,                     & !: 1/dz_soil
               ddz_soil_stag,                & !: 1/dz_soil_stag
@@ -135,62 +164,75 @@
               dz_soil_stag,                 & !: soil grid spacing (edge-edge) 
               root_extr = 0.0_wp,           & !: root extraction
-              root_fraction = (/0.35_wp, 0.38_wp, 0.23_wp, 0.04_wp/), & !: distribution of root surface area to the individual soil layers
-              soil_level = (/0.07_wp, 0.28_wp, 1.00_wp,  2.89_wp/),   & !: soil layer depths (m)
+              root_fraction = (/9999999.9_wp, 9999999.9_wp,    &
+                                9999999.9_wp, 9999999.9_wp /), & !: distribution of root surface area to the individual soil layers
+              zs = (/0.07_wp, 0.28_wp, 1.00_wp,  2.89_wp/),    & !: soil layer depths (m)
               soil_moisture = 0.0_wp          !: soil moisture content (m3/m3)
 
-    REAL(wp), DIMENSION(0:soil_layers) ::   &
+    REAL(wp), DIMENSION(nzb_soil:nzt_soil+1) ::   &
               soil_temperature = 9999999.9_wp !: soil temperature (K)
 
 #if defined( __nopointer )
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE, TARGET :: T_0,    & !: skin temperature (K)
-                                                     T_0_p,  & !: progn. skin temperature (K)
-                                                     m_liq,  & !: liquid water reservoir (m)
-                                                     m_liq_p   !: progn. liquid water reservoir (m)
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE, TARGET :: t_surface,   & !: surface temperature (K)
+                                                     t_surface_p, & !: progn. surface temperature (K)
+                                                     m_liq_eb,    & !: liquid water reservoir (m)
+                                                     m_liq_eb_av, & !: liquid water reservoir (m)
+                                                     m_liq_eb_p     !: progn. liquid water reservoir (m)
 #else
-    REAL(wp), DIMENSION(:,:), POINTER :: T_0,   &
-                                         T_0_p, & 
-                                         m_liq, & 
-                                         m_liq_p
-
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE, TARGET :: T_0_1, T_0_2,    &
-                                                     m_liq_1, m_liq_2
+    REAL(wp), DIMENSION(:,:), POINTER :: t_surface,      &
+                                         t_surface_p,    & 
+                                         m_liq_eb,       & 
+                                         m_liq_eb_p
+
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE, TARGET :: t_surface_1, t_surface_2, &
+                                                     m_liq_eb_av,              &
+                                                     m_liq_eb_1, m_liq_eb_2
 #endif
 
 !
 !-- Temporal tendencies for time stepping            
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE :: tT_0_m,  & !: skin temperature tendency (K)
-                                             tm_liq_m   !: liquid water reservoir tendency (m)
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE :: tt_surface_m,  & !: surface temperature tendency (K)
+                                             tm_liq_eb_m      !: liquid water reservoir tendency (m)
 
 !
 !-- Energy balance variables                
     REAL(wp), DIMENSION(:,:), ALLOCATABLE ::                                   &
-              alpha_VG,      & !: coef. of Van Genuchten
-              c_liq,         & !: liquid water coverage (of vegetated area)
-              c_veg,         & !: vegetation coverage   
-              f_SW_in,       & !: ?
-              G,             & !: surface soil heat flux
-              H,             & !: surface flux of sensible heat
-              gamma_w_sat,   & !: hydraulic conductivity at saturation
-              gD,            & !: coefficient for dependence of r_canopy on water vapour pressure deficit
-              LAI,           & !: leaf area index
-              LE,            & !: surface flux of latent heat (total)
-              LE_veg,        & !: surface flux of latent heat (vegetation portion)
-              LE_soil,       & !: surface flux of latent heat (soil portion)
-              LE_liq,        & !: surface flux of latent heat (liquid water portion)
-              lambda_h_sat,  & !: heat conductivity for dry soil
-              lambda_skin_s, & !: coupling between skin and soil (depends on vegetation type)
-              lambda_skin_u, & !: coupling between skin and soil (depends on vegetation type)
-              l_VG,          & !: coef. of Van Genuchten
-              m_fc,          & !: soil moisture at field capacity (m3/m3)
-              m_res,         & !: residual soil moisture
-              m_sat,         & !: saturation soil moisture (m3/m3)
-              m_wilt,        & !: soil moisture at permanent wilting point (m3/m3)
-              n_VG,          & !: coef. Van Genuchten  
-              r_a,           & !: aerodynamic resistance 
-              r_canopy,      & !: canopy resistance
-              r_soil,        & !: soil resitance
-              r_soil_min,    & !: minimum soil resistance
-              r_s,           & !: total surface resistance (combination of r_soil and r_canopy)          
-              r_s_min          !: minimum canopy resistance
+              alpha_vg,         & !: coef. of Van Genuchten
+              c_liq,            & !: liquid water coverage (of vegetated area)
+              c_liq_av,         & !: average of c_liq
+              c_soil_av,        & !: average of c_soil
+              c_veg,            & !: vegetation coverage
+              c_veg_av,         & !: average of c_veg
+              f_sw_in,          & !: fraction of absorbed shortwave radiation by the surface layer (not implemented yet)
+              ghf_eb,           & !: ground heat flux
+              ghf_eb_av,        & !: average of ghf_eb
+              gamma_w_sat,      & !: hydraulic conductivity at saturation
+              g_d,              & !: coefficient for dependence of r_canopy on water vapour pressure deficit
+              lai,              & !: leaf area index
+              lai_av,           & !: average of lai
+              lambda_h_sat,     & !: heat conductivity for dry soil
+              lambda_surface_s,    & !: coupling between surface and soil (depends on vegetation type)
+              lambda_surface_u,    & !: coupling between surface and soil (depends on vegetation type)
+              l_vg,             & !: coef. of Van Genuchten
+              m_fc,             & !: soil moisture at field capacity (m3/m3)
+              m_res,            & !: residual soil moisture
+              m_sat,            & !: saturation soil moisture (m3/m3)
+              m_wilt,           & !: soil moisture at permanent wilting point (m3/m3)
+              n_vg,             & !: coef. Van Genuchten  
+              qsws_eb,          & !: surface flux of latent heat (total)
+              qsws_eb_av,       & !: average of qsws_eb
+              qsws_liq_eb,      & !: surface flux of latent heat (liquid water portion)
+              qsws_liq_eb_av,   & !: average of qsws_liq_eb
+              qsws_soil_eb,     & !: surface flux of latent heat (soil portion)
+              qsws_soil_eb_av,  & !: average of qsws_soil_eb
+              qsws_veg_eb,      & !: surface flux of latent heat (vegetation portion)
+              qsws_veg_eb_av,   & !: average of qsws_veg_eb
+              r_a,              & !: aerodynamic resistance 
+              r_canopy,         & !: canopy resistance
+              r_soil,           & !: soil resitance
+              r_soil_min,       & !: minimum soil resistance
+              r_s,              & !: total surface resistance (combination of r_soil and r_canopy)          
+              r_canopy_min,     & !: minimum canopy (stomatal) resistance
+              shf_eb,           & !: surface flux of sensible heat
+              shf_eb_av           !: average of shf_eb
 
     REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::                                 &
@@ -198,20 +240,22 @@
               lambda_w, &   !: hydraulic diffusivity of soil (?)
               gamma_w,  &   !: hydraulic conductivity of soil (?)
-              rhoC_total    !: volumetric heat capacity of the actual soil matrix (?) 
+              rho_c_total   !: volumetric heat capacity of the actual soil matrix (?) 
 
 #if defined( __nopointer )
     REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::                         &
-              T_soil,    & !: Soil temperature (K)
-              T_soil_p,  & !: Prog. soil temperature (K)
+              t_soil,    & !: Soil temperature (K)
+              t_soil_av, & !: Average of t_soil
+              t_soil_p,  & !: Prog. soil temperature (K)
               m_soil,    & !: Soil moisture (m3/m3)
+              m_soil_av, & !: Average of m_soil
               m_soil_p     !: Prog. soil moisture (m3/m3)
 #else
     REAL(wp), DIMENSION(:,:,:), POINTER ::                                     &
-              T_soil, T_soil_p, &
+              t_soil, t_soil_p, &
               m_soil, m_soil_p    
 
     REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::                         &
-              T_soil_1, T_soil_2, &
-              m_soil_1, m_soil_2
+              t_soil_av, t_soil_1, t_soil_2,                                   &
+              m_soil_av, m_soil_1, m_soil_2
 
 
@@ -220,33 +264,52 @@
 
     REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::                                 &
-              tT_soil_m, & !: T_soil storage array 
+              tt_soil_m, & !: t_soil storage array 
               tm_soil_m, & !: m_soil storage array 
               root_fr      !: root fraction (sum=1) 
 
-!
-!--  Land surface parameters according to the following classes (veg_type)
-!--  (0 user defined)
-!--  1 crops, mixed farming
-!--  2 short grass
-!--  3 evergreen needleleaf trees
-!--  4 deciduous needleleaf trees
-!--  5 evergreen broadleaf trees
-!--  6 deciduous broadleaf trees
-!--  7 tall grass
-!--  8 desert
-!--  9 tundra
-!-- 10 irrigated crops
-!-- 11 semidesert 
-!-- 12 ice caps and glaciers 
-!-- 13 bogs and marshes 
-!-- 14 inland water 
-!-- 15 ocean 
-!-- 16 evergreen shrubs 
-!-- 17 deciduous shrubs 
-!-- 18 mixed forest/woodland 
-!-- 19 interrupted forest 
-
-!
-!-- Land surface parameters I     r_s_min,     LAI,   c_veg,      gD
+
+!
+!-- Predefined Land surface classes (veg_type)
+    CHARACTER(26), DIMENSION(0:19) :: veg_type_name = (/          &
+                                   'user defined',                & ! 0 
+                                   'crops, mixed farming',        & !  1
+                                   'short grass',                 & !  2
+                                   'evergreen needleleaf trees',  & !  3
+                                   'deciduous needleleaf trees',  & !  4
+                                   'evergreen broadleaf trees' ,  & !  5
+                                   'deciduous broadleaf trees',   & !  6
+                                   'tall grass',                  & !  7
+                                   'desert',                      & !  8
+                                   'tundra',                      & !  9
+                                   'irrigated crops',             & ! 10
+                                   'semidesert',                  & ! 11
+                                   'ice caps and glaciers' ,      & ! 12
+                                   'bogs and marshes',            & ! 13
+                                   'inland water',                & ! 14
+                                   'ocean',                       & ! 15
+                                   'evergreen shrubs',            & ! 16
+                                   'deciduous shrubs',            & ! 17
+                                   'mixed forest/woodland',       & ! 18
+                                   'interrupted forest'           & ! 19
+                                                       /)
+
+!
+!-- Soil model classes (soil_type)
+    CHARACTER(12), DIMENSION(0:7) :: soil_type_name = (/ &
+                                   'user defined',        & ! 0 
+                                   'coarse',              & ! 1
+                                   'medium',              & ! 2
+                                   'medium-fine',         & ! 3
+                                   'fine',                & ! 4
+                                   'very fine' ,          & ! 5
+                                   'organic',             & ! 6
+                                   'loamy (CH)'           & ! 7
+                                                        /)
+!
+!-- Land surface parameters according to the respective classes (veg_type)
+
+!
+!-- Land surface parameters I
+!--                          r_canopy_min,     lai,   c_veg,     g_d
     REAL(wp), DIMENSION(0:3,1:19) :: veg_pars = RESHAPE( (/           &
                                  180.0_wp, 3.00_wp, 0.90_wp, 0.00_wp, & !  1
@@ -257,5 +320,5 @@
                                  240.0_wp, 6.00_wp, 0.99_wp, 0.13_wp, & !  6
                                  100.0_wp, 2.00_wp, 0.70_wp, 0.00_wp, & !  7
-                                 250.0_wp, 0.50_wp, 0.00_wp, 0.00_wp, & !  8
+                                 250.0_wp, 0.05_wp, 0.00_wp, 0.00_wp, & !  8
                                   80.0_wp, 1.00_wp, 0.50_wp, 0.00_wp, & !  9
                                  180.0_wp, 3.00_wp, 0.90_wp, 0.00_wp, & ! 10
@@ -296,6 +359,6 @@
 
 !
-!-- Land surface parameters III lambda_skin_s, lambda_skin_u, f_SW_in
-    REAL(wp), DIMENSION(0:2,1:19) :: skin_pars = RESHAPE( (/           &
+!-- Land surface parameters III lambda_surface_s, lambda_surface_u, f_sw_in
+    REAL(wp), DIMENSION(0:2,1:19) :: surface_pars = RESHAPE( (/           &
                                       10.0_wp,       10.0_wp, 0.05_wp, & !  1
                                       10.0_wp,       10.0_wp, 0.05_wp, & !  2
@@ -345,14 +408,8 @@
 !
 !-- Soil parameters according to the following porosity classes (soil_type)
-!-- (0 user defined)
-!-- 1 coarse
-!-- 2 medium
-!-- 3 medium-fine
-!-- 4 fine
-!-- 5 very fine
-!-- 6 organic
-!
-!-- Soil parameters I           alpha_VG,      l_VG,    n_VG, gamma_w_sat
-    REAL(wp), DIMENSION(0:3,1:6) :: soil_pars = RESHAPE( (/                &
+
+!
+!-- Soil parameters I           alpha_vg,      l_vg,    n_vg, gamma_w_sat
+    REAL(wp), DIMENSION(0:3,1:7) :: soil_pars = RESHAPE( (/                &
                                  3.83_wp,  1.250_wp, 1.38_wp,  6.94E-6_wp, & ! 1
                                  3.14_wp, -2.342_wp, 1.28_wp,  1.16E-6_wp, & ! 2
@@ -360,10 +417,11 @@
                                  3.67_wp, -1.977_wp, 1.10_wp,  2.87E-6_wp, & ! 4
                                  2.65_wp,  2.500_wp, 1.10_wp,  1.74E-6_wp, & ! 5
-                                 1.30_wp,  0.400_wp, 1.20_wp,  0.93E-6_wp  & ! 6
-                                 /), (/ 4, 6 /) )
+                                 1.30_wp,  0.400_wp, 1.20_wp,  0.93E-6_wp, & ! 6
+                                 0.00_wp,  0.00_wp,  0.00_wp,  0.57E-6_wp  & ! 7
+                                 /), (/ 4, 7 /) )
 
 !
 !-- Soil parameters II              m_sat,     m_fc,   m_wilt,    m_res  
-    REAL(wp), DIMENSION(0:3,1:6) :: m_soil_pars = RESHAPE( (/            &
+    REAL(wp), DIMENSION(0:3,1:7) :: m_soil_pars = RESHAPE( (/            &
                                  0.403_wp, 0.244_wp, 0.059_wp, 0.025_wp, & ! 1
                                  0.439_wp, 0.347_wp, 0.151_wp, 0.010_wp, & ! 2
@@ -371,6 +429,7 @@
                                  0.520_wp, 0.448_wp, 0.279_wp, 0.010_wp, & ! 4
                                  0.614_wp, 0.541_wp, 0.335_wp, 0.010_wp, & ! 5
-                                 0.766_wp, 0.663_wp, 0.267_wp, 0.010_wp  & ! 6
-                                 /), (/ 4, 6 /) )
+                                 0.766_wp, 0.663_wp, 0.267_wp, 0.010_wp, & ! 6
+                                 0.472_wp, 0.323_wp, 0.171_wp, 0.000_wp  & ! 7
+                                 /), (/ 4, 7 /) )
 
 
@@ -381,21 +440,36 @@
 
 
-    PUBLIC alpha_VanGenuchten, C_skin, canopy_resistance_coefficient,          &
-           conserve_water_content,      field_capacity, f_shortwave_incoming,  &
-           hydraulic_conductivity, init_lsm, lambda_skin_stable,               &
-           lambda_skin_unstable, land_surface, leaf_area_index,                &
-           lsm_energy_balance, lsm_soil_model, l_VanGenuchten,                 &
-           min_canopy_resistance, n_VanGenuchten, residual_moisture,           &
-           root_fraction, saturation_moisture, soil_level, soil_moisture,      &
-           soil_temperature, soil_type, vegetation_coverage, veg_type,         &
-           wilting_point
-
-#if defined( __nopointer )
-    PUBLIC m_liq, m_liq_p, m_soil, m_soil_p, T_0, T_0_p, T_soil, T_soil_p
-#else
-    PUBLIC m_liq, m_liq_1, m_liq_2, m_liq_p, m_soil, m_soil_1, m_soil_2,       &
-           m_soil_p, T_0, T_0_1, T_0_2, T_0_p, T_soil, T_soil_1, T_soil_2,     &
-           T_soil_p
-#endif
+!
+!-- Public parameters, constants and initial values
+    PUBLIC alpha_vangenuchten, c_surface, canopy_resistance_coefficient,       &
+           conserve_water_content, dewfall, field_capacity,                    &
+           f_shortwave_incoming, hydraulic_conductivity, init_lsm,             &
+           init_lsm_arrays, lambda_surface_stable, lambda_surface_unstable,    &
+           land_surface, leaf_area_index, lsm_energy_balance, lsm_soil_model,  &
+           lsm_swap_timelevel, l_vangenuchten, min_canopy_resistance,          &
+           min_soil_resistance, n_vangenuchten, residual_moisture, rho_cp,     &
+           rho_lv, root_fraction, saturation_moisture, soil_moisture,          &
+           soil_temperature, soil_type, soil_type_name, vegetation_coverage,   &
+           veg_type, veg_type_name, wilting_point, z0_eb, z0h_eb
+
+!
+!-- Public grid and NetCDF variables
+    PUBLIC dots_soil, id_dim_zs_xy, id_dim_zs_xz, id_dim_zs_yz,                &
+           id_dim_zs_3d, id_dim_zs_mask, id_var_zs_xy, id_var_zs_xz,           &
+           id_var_zs_yz, id_var_zs_3d, id_var_zs_mask, nzb_soil, nzs, nzt_soil,&
+           zs
+
+
+!
+!-- Public 2D output variables
+    PUBLIC c_liq, c_liq_av, c_soil_av, c_veg, c_veg_av, ghf_eb, ghf_eb_av,     &
+           lai, lai_av, qsws_eb, qsws_eb_av, qsws_liq_eb, qsws_liq_eb_av,      &
+           qsws_soil_eb, qsws_soil_eb_av, qsws_veg_eb, qsws_veg_eb_av,         &
+           shf_eb, shf_eb_av
+
+
+!
+!-- Public prognostic variables
+    PUBLIC m_liq_eb, m_liq_eb_av, m_soil, m_soil_av, t_soil, t_soil_av
 
 
